=== modified file 'account_period_closing_level/__openerp__.py'
--- account_period_closing_level/__openerp__.py	2011-04-01 07:02:04 +0000
+++ account_period_closing_level/__openerp__.py	2012-01-30 16:52:46 +0000
@@ -21,7 +21,7 @@
 {
     "name": "Account Period for MSF",
     "version": "1.0",
-    "depends": ["account"],
+    "depends": ["account_subscription"],
     "author" : "MSF: Matthieu Dietrich",
     "category": "General/Standard",
     "description": """

=== modified file 'account_period_closing_level/account_period.py'
--- account_period_closing_level/account_period.py	2012-01-10 10:12:56 +0000
+++ account_period_closing_level/account_period.py	2012-01-30 16:52:46 +0000
@@ -52,6 +52,7 @@
         
         # Prepare some elements
         reg_obj = self.pool.get('account.bank.statement')
+        sub_obj = self.pool.get('account.subscription.line')
         curr_obj = self.pool.get('res.currency')
         curr_rate_obj = self.pool.get('res.currency.rate')
         inv_obj = self.pool.get('account.invoice')
@@ -64,6 +65,10 @@
                 for register in reg_obj.browse(cr, uid, reg_ids, context=context):
                     if register.state not in ['confirm']:
                         raise osv.except_osv(_('Warning'), _("The register '%s' is not closed. Please close it before closing period" % register.name))
+                # check if subscriptions lines were not created for this period
+                sub_ids = sub_obj.search(cr, uid, [('date', '<', period.date_stop), ('move_id', '=', False)], context=context)
+                if len(sub_ids) > 0:
+                    raise osv.except_osv(_('Warning'), _("Recurring entries were not created for period '%s'. Please create them before closing period" % period.name))
                 # then verify that all currencies have a fx rate in this period
                 # retrieve currencies for this period (in account_move_lines)
                 sql = """SELECT DISTINCT currency_id
@@ -110,6 +115,7 @@
                         'period_id': period.id,
                     }
                 }
+                
         
         # check if unposted move lines are linked to this period
         move_line_obj = self.pool.get('account.move.line')
@@ -117,6 +123,8 @@
         for move_line in move_line_obj.browse(cr, uid, move_lines):
             if move_line.state != 'valid':
                 raise osv.except_osv(_('Error !'), _('You cannot close a period containing unbalanced move lines!'))
+            
+
         
         # otherwise, change the period's and journal period's states
         if context['state']:

=== added directory 'account_subscription'
=== added file 'account_subscription/__init__.py'
--- account_subscription/__init__.py	1970-01-01 00:00:00 +0000
+++ account_subscription/__init__.py	2012-01-30 16:52:46 +0000
@@ -0,0 +1,24 @@
+# -*- coding: utf-8 -*-
+##############################################################################
+#
+#    OpenERP, Open Source Management Solution
+#    Copyright (C) 2011 MSF, TeMPO consulting
+#
+#    This program is free software: you can redistribute it and/or modify
+#    it under the terms of the GNU Affero General Public License as
+#    published by the Free Software Foundation, either version 3 of the
+#    License, or (at your option) any later version.
+#
+#    This program is distributed in the hope that it will be useful,
+#    but WITHOUT ANY WARRANTY; without even the implied warranty of
+#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+#    GNU Affero General Public License for more details.
+#
+#    You should have received a copy of the GNU Affero General Public License
+#    along with this program.  If not, see <http://www.gnu.org/licenses/>.
+#
+##############################################################################
+
+import account_model
+
+# vim:expandtab:smartindent:tabstop=4:softtabstop=4:shiftwidth=4:

=== added file 'account_subscription/__openerp__.py'
--- account_subscription/__openerp__.py	1970-01-01 00:00:00 +0000
+++ account_subscription/__openerp__.py	2012-01-30 16:52:46 +0000
@@ -0,0 +1,44 @@
+# -*- coding: utf-8 -*-
+##############################################################################
+#
+#    OpenERP, Open Source Management Solution
+#    Copyright (C) 2011 MSF, TeMPO consulting
+#
+#    This program is free software: you can redistribute it and/or modify
+#    it under the terms of the GNU Affero General Public License as
+#    published by the Free Software Foundation, either version 3 of the
+#    License, or (at your option) any later version.
+#
+#    This program is distributed in the hope that it will be useful,
+#    but WITHOUT ANY WARRANTY; without even the implied warranty of
+#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+#    GNU Affero General Public License for more details.
+#
+#    You should have received a copy of the GNU Affero General Public License
+#    along with this program.  If not, see <http://www.gnu.org/licenses/>.
+#
+##############################################################################
+{
+    "name": "Recurring Entries for MSF",
+    "version": "1.0",
+    "depends": ["analytic_distribution"],
+    "author" : "MSF",
+    "category": "General/Standard",
+    "description": """
+    This module adds analytic distribution and period checks to
+    the standard behavior of recurring entries.
+    Period checks are done in account_period_closing_level module.
+    
+    """,
+    "init_xml": [],
+    'update_xml': [
+        'account_model_view.xml'
+    ],
+    "test": [
+    ],
+    'demo_xml': [],
+    'installable': True,
+    'active': False,
+#    'certificate': 'certificate',
+}
+# vim:expandtab:smartindent:tabstop=4:softtabstop=4:shiftwidth=4:

=== added file 'account_subscription/account_model.py'
--- account_subscription/account_model.py	1970-01-01 00:00:00 +0000
+++ account_subscription/account_model.py	2012-01-30 16:52:46 +0000
@@ -0,0 +1,163 @@
+#!/usr/bin/env python
+# -*- coding: utf-8 -*-
+##############################################################################
+#
+#    OpenERP, Open Source Management Solution
+#    Copyright (C) 2011 TeMPO Consulting, MSF. All Rights Reserved
+#
+#    This program is free software: you can redistribute it and/or modify
+#    it under the terms of the GNU Affero General Public License as
+#    published by the Free Software Foundation, either version 3 of the
+#    License, or (at your option) any later version.
+#
+#    This program is distributed in the hope that it will be useful,
+#    but WITHOUT ANY WARRANTY; without even the implied warranty of
+#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+#    GNU Affero General Public License for more details.
+#
+#    You should have received a copy of the GNU Affero General Public License
+#    along with this program.  If not, see <http://www.gnu.org/licenses/>.
+#
+##############################################################################
+from osv import fields, osv
+import time
+from datetime import datetime
+from dateutil.relativedelta import relativedelta
+
+class account_model_line(osv.osv):
+    _name = "account.model.line"
+    _inherit = "account.model.line"
+    
+    _columns = {
+        'analytic_distribution_id': fields.many2one('analytic.distribution', 'Analytic Distribution'),
+        'account_user_type_code': fields.related('account_id', 'user_type_code', type="selection", string="Account User Type Code", store=False)
+    }
+    
+    def button_analytic_distribution(self, cr, uid, ids, context={}):
+        """
+        Launch analytic distribution wizard on an invoice line
+        """
+        # Some verifications
+        if not context:
+            context = {}
+        if isinstance(ids, (int, long)):
+            ids = [ids]
+        if not ids:
+            raise osv.except_osv(_('Error'), _('No model line given. Please save your model line before.'))
+        model_line = self.browse(cr, uid, ids[0], context=context)
+        distrib_id = False
+        amount = abs(model_line.debit - model_line.credit)
+        currency = self.pool.get('res.users').browse(cr, uid, uid, context=context).company_id.currency_id.id
+        # Get analytic distribution id from this line
+        distrib_id = model_line.analytic_distribution_id and model_line.analytic_distribution_id.id or False
+        # Prepare values for wizard
+        vals = {
+            'total_amount': amount,
+            'model_line_id': model_line.id,
+            'currency_id': currency,
+            'state': 'dispatch',
+            'account_id': model_line.account_id.id,
+        }
+        if distrib_id:
+            vals.update({'distribution_id': distrib_id,})
+        # Create the wizard
+        wiz_obj = self.pool.get('analytic.distribution.wizard')
+        wiz_id = wiz_obj.create(cr, uid, vals, context=context)
+        # Update some context values
+        context.update({
+            'active_id': ids[0],
+            'active_ids': ids,
+        })
+        # Open it!
+        return {
+                'type': 'ir.actions.act_window',
+                'res_model': 'analytic.distribution.wizard',
+                'view_type': 'form',
+                'view_mode': 'form',
+                'target': 'new',
+                'res_id': [wiz_id],
+                'context': context,
+        }
+    
+account_model_line()
+
+class account_model(osv.osv):
+    _name = "account.model"
+    _inherit = "account.model"
+    
+    # @@@override@account.account_model.generate()
+    def generate(self, cr, uid, ids, datas={}, context=None):
+        move_ids = []
+        entry = {}
+        account_move_obj = self.pool.get('account.move')
+        account_move_line_obj = self.pool.get('account.move.line')
+        pt_obj = self.pool.get('account.payment.term')
+        ana_obj = self.pool.get('analytic.distribution')
+
+        if context is None:
+            context = {}
+
+        if datas.get('date', False):
+            context.update({'date': datas['date']})
+
+        period_id = self.pool.get('account.period').find(cr, uid, dt=context.get('date', False))
+        if not period_id:
+            raise osv.except_osv(_('No period found !'), _('Unable to find a valid period !'))
+        period_id = period_id[0]
+
+        for model in self.browse(cr, uid, ids, context=context):
+            entry['name'] = model.name%{'year':time.strftime('%Y'), 'month':time.strftime('%m'), 'date':time.strftime('%Y-%m')}
+            move_id = account_move_obj.create(cr, uid, {
+                'ref': entry['name'],
+                'period_id': period_id,
+                'journal_id': model.journal_id.id,
+                'date': context.get('date',time.strftime('%Y-%m-%d'))
+            })
+            move_ids.append(move_id)
+            for line in model.lines_id:
+                val = {
+                    'move_id': move_id,
+                    'journal_id': model.journal_id.id,
+                    'period_id': period_id,
+                }
+                if line.account_id.user_type_code == 'expense':
+                    if not line.analytic_distribution_id:
+                        raise osv.except_osv(_('No Analytic Distribution !'),_("You have to define an analytic distribution on the '%s' line!") % (line.name))
+                    if not model.journal_id.analytic_journal_id:
+                        raise osv.except_osv(_('No Analytic Journal !'),_("You have to define an analytic journal on the '%s' journal!") % (model.journal_id.name,))
+                    new_distribution_id = ana_obj.copy(cr, uid, line.analytic_distribution_id.id, {}, context=context)
+                    val.update({'analytic_distribution_id': new_distribution_id})
+                    
+                date_maturity = time.strftime('%Y-%m-%d')
+                if line.date_maturity == 'partner':
+                    if not line.partner_id:
+                        raise osv.except_osv(_('Error !'), _("Maturity date of entry line generated by model line '%s' of model '%s' is based on partner payment term!" \
+                                                                "\nPlease define partner on it!")%(line.name, model.name))
+                    if line.partner_id.property_payment_term:
+                        payment_term_id = line.partner_id.property_payment_term.id
+                        pterm_list = pt_obj.compute(cr, uid, payment_term_id, value=1, date_ref=date_maturity)
+                        if pterm_list:
+                            pterm_list = [l[0] for l in pterm_list]
+                            pterm_list.sort()
+                            date_maturity = pterm_list[-1]
+
+                val.update({
+                    'name': line.name,
+                    'quantity': line.quantity,
+                    'debit': line.debit,
+                    'credit': line.credit,
+                    'account_id': line.account_id.id,
+                    'move_id': move_id,
+                    'partner_id': line.partner_id.id,
+                    'date': context.get('date',time.strftime('%Y-%m-%d')),
+                    'date_maturity': date_maturity
+                })
+                c = context.copy()
+                c.update({'journal_id': model.journal_id.id,'period_id': period_id})
+                account_move_line_obj.create(cr, uid, val, context=c)
+
+        return move_ids
+
+account_model()
+
+# vim:expandtab:smartindent:tabstop=4:softtabstop=4:shiftwidth=4:

=== added file 'account_subscription/account_model_view.xml'
--- account_subscription/account_model_view.xml	1970-01-01 00:00:00 +0000
+++ account_subscription/account_model_view.xml	2012-01-30 16:52:46 +0000
@@ -0,0 +1,17 @@
+<?xml version="1.0" encoding="UTF-8"?>
+<openerp>
+    <data>
+        <record id="view_model_line_distrib_tree" model="ir.ui.view">
+            <field name="name">account.model.line.distrib.tree</field>
+            <field name="model">account.model.line</field>
+            <field name="type">tree</field>
+            <field name="inherit_id" ref="account.view_model_line_tree"/>
+            <field name="arch" type="xml">
+                <field name="analytic_account_id" position="replace">
+                    <field name="account_user_type_code" invisible="1"/>
+                    <button name="button_analytic_distribution" type="object" icon="terp-stock_symbol-selection" string="Analytic Distribution" attrs="{'invisible': [('account_user_type_code', '!=', 'expense')]}"/>
+                </field>
+            </field>
+        </record>
+    </data>
+</openerp>
\ No newline at end of file

=== modified file 'analytic_distribution/wizard/analytic_distribution_wizard.py'
--- analytic_distribution/wizard/analytic_distribution_wizard.py	2012-01-06 17:25:59 +0000
+++ analytic_distribution/wizard/analytic_distribution_wizard.py	2012-01-30 16:52:46 +0000
@@ -415,6 +415,7 @@
         'move_line_id': fields.many2one('account.move.line', string="Journal Item"),
         'commitment_id': fields.many2one('account.commitment', string="Commitment Voucher"),
         'commitment_line_id': fields.many2one('account.commitment.line', string="Commitment Voucher Line"),
+        'model_line_id': fields.many2one('account.model.line', string="Account Model Line"),
         'distribution_id': fields.many2one('analytic.distribution', string="Analytic Distribution"),
         'is_writable': fields.function(_is_writable, method=True, string='Is this wizard writable?', type='boolean', readonly=True, 
             help="This informs wizard if it could be saved or not regarding invoice state or purchase order state", store=False),
@@ -734,7 +735,7 @@
                     ('purchase_line_id', 'purchase.order.line'), ('register_line_id', 'account.bank.statement.line'), 
                     ('move_line_id', 'account.move.line'), ('direct_invoice_id', 'wizard.account.invoice'), 
                     ('direct_invoice_line_id', 'wizard.account.invoice.line'), ('commitment_id', 'account.commitment'), 
-                    ('commitment_line_id', 'account.commitment.line')]:
+                    ('commitment_line_id', 'account.commitment.line'), ('model_line_id', 'account.model.line')]:
                     if getattr(wiz, el[0], False):
                         id = getattr(wiz, el[0], False).id
                         self.pool.get(el[1]).write(cr, uid, [id], {'analytic_distribution_id': distrib_id}, context=context)

=== modified file 'data_supply/data.xml'
--- data_supply/data.xml	2012-01-16 16:47:20 +0000
+++ data_supply/data.xml	2012-01-30 16:52:46 +0000
@@ -664,15 +664,5 @@
         <function model="stock.inventory" name="action_done">
             <function model="stock.inventory" name="search" eval="[[('id', '=', ref('stock_inventory_stock_initialisation_2_2'))]]"/>
         </function>
-
-        <record id="specific_rules.sequence_production_lots" model="ir.sequence">
-            <field name="name">Batch Numbers</field>
-            <field name="code">stock.lot.serial</field>
-            <field name="prefix">MSFBN/</field>
-            <field name="padding">6</field>
-            <field name="number_next">6</field>
-            <field name="number_increment">1</field>
-        </record>
-
     </data>
 </openerp>

=== modified file 'msf_order_date/order_dates.py'
--- msf_order_date/order_dates.py	2012-01-16 13:45:37 +0000
+++ msf_order_date/order_dates.py	2012-01-30 16:52:46 +0000
@@ -948,7 +948,7 @@
         return res
     
     _columns = {
-        'date_order':fields.date(string='Creation Date', required=True, select=True, readonly=True, help="Date on which this document has been created.", states={'draft': [('readonly', False)]}),
+        'date_order':fields.date(string='Creation Date', required=True, select=True, readonly=True, help="Date on which this document has been created."),
         'delivery_requested_date': fields.date(string='Delivery Requested Date', required=True),
         'delivery_confirmed_date': fields.date(string='Delivery Confirmed Date'),
         'ready_to_ship_date': fields.date(string='Ready To Ship Date', required=True),

=== modified file 'msf_profile/__openerp__.py'
--- msf_profile/__openerp__.py	2011-12-30 16:15:01 +0000
+++ msf_profile/__openerp__.py	2012-01-30 16:52:46 +0000
@@ -85,6 +85,7 @@
         "transport_mgmt",
         "documents_done",
         "msf_budget",
+        "account_subscription",
     ],
     "update_xml": [
         "report.xml",

=== modified file 'tender_flow/tender_flow.py'
--- tender_flow/tender_flow.py	2012-01-17 08:44:01 +0000
+++ tender_flow/tender_flow.py	2012-01-30 16:52:46 +0000
@@ -95,7 +95,7 @@
                 'categ': fields.selection(ORDER_CATEGORY, string='Tender Category', required=True, states={'draft':[('readonly',False)],}, readonly=True),
                 'creator': fields.many2one('res.users', string="Creator", readonly=True, required=True,),
                 'warehouse_id': fields.many2one('stock.warehouse', string="Warehouse", required=True, states={'draft':[('readonly',False)],}, readonly=True),
-                'creation_date': fields.date(string="Creation Date", readonly=True, states={'draft':[('readonly',False)]}),
+                'creation_date': fields.date(string="Creation Date", readonly=True),
                 'details': fields.char(size=30, string="Details", states={'draft':[('readonly',False)],}, readonly=True),
                 'requested_date': fields.date(string="Requested Date", required=True, states={'draft':[('readonly',False)],}, readonly=True),
                 'notes': fields.text('Notes'),

